from sys import argv
from math import sqrt
from munkres import Munkres, DISALLOWED, print_matrix
#import matplotlib.pyplot as plt

def readMol2(fname):
    f=open(fname)
    coords=[]
    atoms=[]
    readflag=False
    labels=[]
    n=0
    for line in f:
        if line.strip()=="@<TRIPOS>BOND":
            break
        elif line.strip()=="@<TRIPOS>ATOM":
            readflag=True
        elif readflag:
            n+=1
            parts=line.split()
            if parts[5]=="H":
                continue
            coords.append([float(i) for i in parts[2:5]])
            atoms.append(parts[5].split('.')[0])
            labels.append(parts[5]+str(n))
        else:
            continue
    return (coords,atoms,labels)

query=readMol2(argv[1])
querycoords=query[0]
queryatoms=query[1]
querylabels=query[2]
temp=readMol2(argv[2])
tempcoords=temp[0]
tempatoms=temp[1]
templabels=temp[2]

if len(querycoords)!=len(tempcoords):
    print("identical atomcount needed")
    exit(1)

'''
querysort=[(queryatoms[i],i) for i in range(len(queryatoms))]
querysort=sorted(querysort,key=lambda x:x[0])
queryatoms=[element[0] for element in querysort]
tempatoms=queryatoms
tempsort=[(tempatoms[i],i) for i in range(len(tempatoms))]
tempsort=sorted(tempsort,key=lambda x:x[0])
tempatoms=[element[0] for element in tempsort]
print(querysort)
print(tempsort)
qsortcoords=[querycoords[element[1]] for element in querysort]
querycoords=qsortcoords
tsortcoords=[tempcoords[element[1]] for element in querysort]
tempcoords=tsortcoords
'''
distmat=[[0. for j in range(len(tempcoords))] for i in range(len(querycoords))]
showmat=[[0. for j in range(len(tempcoords))] for i in range(len(querycoords))]
for i in range(len(querycoords)):
    for j in range(len(tempcoords)):
        if queryatoms[i]==tempatoms[j]:
            distmat[i][j]=int(sum([(querycoords[i][k]-tempcoords[j][k])**2 for k in range(3)]*10000))
            showmat[i][j]=distmat[i][j]
        else:
            distmat[i][j]=DISALLOWED
            showmat[i][j]=0.0


m=Munkres()
try:
    indexes=m.compute(distmat)
    #print_matrix(distmat)
except Exception as e:
    print(e)
    #print(querysort)
    #print(tempsort)
    #plt.matshow(showmat)
    #plt.show()
    exit(1)

squaredist=0.
for row, column in indexes:
    #print((querylabels[row],templabels[column],distmat[row][column]))
    squaredist+=(float(distmat[row][column])/10000)/len(querycoords)

print("%.3f"%(sqrt(squaredist)))
